/* Autogenerated file. Do not edit manually. */
/* tslint:disable */
/* eslint-disable */
import type {
  BaseContract,
  BigNumber,
  BigNumberish,
  BytesLike,
  CallOverrides,
  ContractTransaction,
  Overrides,
  PopulatedTransaction,
  Signer,
  utils,
} from "ethers";
import type {
  FunctionFragment,
  Result,
  EventFragment,
} from "@ethersproject/abi";
import type { Listener, Provider } from "@ethersproject/providers";
import type {
  TypedEventFilter,
  TypedEvent,
  TypedListener,
  OnEvent,
  PromiseOrValue,
} from "../common";

export declare namespace MLTToken {
  export type AllocationStruct = {
    unlocking: PromiseOrValue<BigNumberish>;
    monthly: PromiseOrValue<BigNumberish>[];
    months: PromiseOrValue<BigNumberish>[];
    cliff: PromiseOrValue<BigNumberish>;
  };

  export type AllocationStructOutput = [
    BigNumber,
    BigNumber[],
    BigNumber[],
    BigNumber
  ] & {
    unlocking: BigNumber;
    monthly: BigNumber[];
    months: BigNumber[];
    cliff: BigNumber;
  };

  export type VestingDataStruct = {
    beneficiary: PromiseOrValue<string>;
    amount: PromiseOrValue<BigNumberish>;
    cliff: PromiseOrValue<BigNumberish>;
    proof: PromiseOrValue<BytesLike>[];
  };

  export type VestingDataStructOutput = [
    string,
    BigNumber,
    BigNumber,
    string[]
  ] & {
    beneficiary: string;
    amount: BigNumber;
    cliff: BigNumber;
    proof: string[];
  };
}

export interface MLTTokenInterface extends utils.Interface {
  functions: {
    "VESTING_START_TIMESTAMP()": FunctionFragment;
    "addRoot(bytes32,bytes32,uint256,string,(uint256,uint256[],uint256[],uint256),bytes32[],bytes32[],bytes32[],bytes32[],(address,uint256,uint256,bytes32[])[])": FunctionFragment;
    "allowance(address,address)": FunctionFragment;
    "approve(address,uint256)": FunctionFragment;
    "balanceByRootHash(bytes32)": FunctionFragment;
    "balanceOf(address)": FunctionFragment;
    "batchReleaseVested((address,uint256,uint256,bytes32[])[],bytes32)": FunctionFragment;
    "decimals()": FunctionFragment;
    "decreaseAllowance(address,uint256)": FunctionFragment;
    "increaseAllowance(address,uint256)": FunctionFragment;
    "isTreasurer(address)": FunctionFragment;
    "mapRootURIs(bytes32)": FunctionFragment;
    "name()": FunctionFragment;
    "releaseVested(address,uint256,uint256,bytes32,bytes32[])": FunctionFragment;
    "rootURIs(uint256)": FunctionFragment;
    "rootWhitelist(bytes32)": FunctionFragment;
    "symbol()": FunctionFragment;
    "totalSupply()": FunctionFragment;
    "transfer(address,uint256)": FunctionFragment;
    "transferFrom(address,address,uint256)": FunctionFragment;
    "verifyProof(address,uint256,uint256,bytes32,bytes32[])": FunctionFragment;
    "vestingClaimed(bytes32)": FunctionFragment;
  };

  getFunction(
    nameOrSignatureOrTopic:
      | "VESTING_START_TIMESTAMP"
      | "addRoot"
      | "allowance"
      | "approve"
      | "balanceByRootHash"
      | "balanceOf"
      | "batchReleaseVested"
      | "decimals"
      | "decreaseAllowance"
      | "increaseAllowance"
      | "isTreasurer"
      | "mapRootURIs"
      | "name"
      | "releaseVested"
      | "rootURIs"
      | "rootWhitelist"
      | "symbol"
      | "totalSupply"
      | "transfer"
      | "transferFrom"
      | "verifyProof"
      | "vestingClaimed"
  ): FunctionFragment;

  encodeFunctionData(
    functionFragment: "VESTING_START_TIMESTAMP",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "addRoot",
    values: [
      PromiseOrValue<BytesLike>,
      PromiseOrValue<BytesLike>,
      PromiseOrValue<BigNumberish>,
      PromiseOrValue<string>,
      MLTToken.AllocationStruct,
      PromiseOrValue<BytesLike>[],
      PromiseOrValue<BytesLike>[],
      PromiseOrValue<BytesLike>[],
      PromiseOrValue<BytesLike>[],
      MLTToken.VestingDataStruct[]
    ]
  ): string;
  encodeFunctionData(
    functionFragment: "allowance",
    values: [PromiseOrValue<string>, PromiseOrValue<string>]
  ): string;
  encodeFunctionData(
    functionFragment: "approve",
    values: [PromiseOrValue<string>, PromiseOrValue<BigNumberish>]
  ): string;
  encodeFunctionData(
    functionFragment: "balanceByRootHash",
    values: [PromiseOrValue<BytesLike>]
  ): string;
  encodeFunctionData(
    functionFragment: "balanceOf",
    values: [PromiseOrValue<string>]
  ): string;
  encodeFunctionData(
    functionFragment: "batchReleaseVested",
    values: [MLTToken.VestingDataStruct[], PromiseOrValue<BytesLike>]
  ): string;
  encodeFunctionData(functionFragment: "decimals", values?: undefined): string;
  encodeFunctionData(
    functionFragment: "decreaseAllowance",
    values: [PromiseOrValue<string>, PromiseOrValue<BigNumberish>]
  ): string;
  encodeFunctionData(
    functionFragment: "increaseAllowance",
    values: [PromiseOrValue<string>, PromiseOrValue<BigNumberish>]
  ): string;
  encodeFunctionData(
    functionFragment: "isTreasurer",
    values: [PromiseOrValue<string>]
  ): string;
  encodeFunctionData(
    functionFragment: "mapRootURIs",
    values: [PromiseOrValue<BytesLike>]
  ): string;
  encodeFunctionData(functionFragment: "name", values?: undefined): string;
  encodeFunctionData(
    functionFragment: "releaseVested",
    values: [
      PromiseOrValue<string>,
      PromiseOrValue<BigNumberish>,
      PromiseOrValue<BigNumberish>,
      PromiseOrValue<BytesLike>,
      PromiseOrValue<BytesLike>[]
    ]
  ): string;
  encodeFunctionData(
    functionFragment: "rootURIs",
    values: [PromiseOrValue<BigNumberish>]
  ): string;
  encodeFunctionData(
    functionFragment: "rootWhitelist",
    values: [PromiseOrValue<BytesLike>]
  ): string;
  encodeFunctionData(functionFragment: "symbol", values?: undefined): string;
  encodeFunctionData(
    functionFragment: "totalSupply",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "transfer",
    values: [PromiseOrValue<string>, PromiseOrValue<BigNumberish>]
  ): string;
  encodeFunctionData(
    functionFragment: "transferFrom",
    values: [
      PromiseOrValue<string>,
      PromiseOrValue<string>,
      PromiseOrValue<BigNumberish>
    ]
  ): string;
  encodeFunctionData(
    functionFragment: "verifyProof",
    values: [
      PromiseOrValue<string>,
      PromiseOrValue<BigNumberish>,
      PromiseOrValue<BigNumberish>,
      PromiseOrValue<BytesLike>,
      PromiseOrValue<BytesLike>[]
    ]
  ): string;
  encodeFunctionData(
    functionFragment: "vestingClaimed",
    values: [PromiseOrValue<BytesLike>]
  ): string;

  decodeFunctionResult(
    functionFragment: "VESTING_START_TIMESTAMP",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "addRoot", data: BytesLike): Result;
  decodeFunctionResult(functionFragment: "allowance", data: BytesLike): Result;
  decodeFunctionResult(functionFragment: "approve", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "balanceByRootHash",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "balanceOf", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "batchReleaseVested",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "decimals", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "decreaseAllowance",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "increaseAllowance",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "isTreasurer",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "mapRootURIs",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "name", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "releaseVested",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "rootURIs", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "rootWhitelist",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "symbol", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "totalSupply",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "transfer", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "transferFrom",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "verifyProof",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "vestingClaimed",
    data: BytesLike
  ): Result;

  events: {
    "AddedRoot(bytes32)": EventFragment;
    "Approval(address,address,uint256)": EventFragment;
    "Transfer(address,address,uint256)": EventFragment;
    "VestedTokenGrant(bytes32)": EventFragment;
  };

  getEvent(nameOrSignatureOrTopic: "AddedRoot"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "Approval"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "Transfer"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "VestedTokenGrant"): EventFragment;
}

export interface AddedRootEventObject {
  root: string;
}
export type AddedRootEvent = TypedEvent<[string], AddedRootEventObject>;

export type AddedRootEventFilter = TypedEventFilter<AddedRootEvent>;

export interface ApprovalEventObject {
  owner: string;
  spender: string;
  value: BigNumber;
}
export type ApprovalEvent = TypedEvent<
  [string, string, BigNumber],
  ApprovalEventObject
>;

export type ApprovalEventFilter = TypedEventFilter<ApprovalEvent>;

export interface TransferEventObject {
  from: string;
  to: string;
  value: BigNumber;
}
export type TransferEvent = TypedEvent<
  [string, string, BigNumber],
  TransferEventObject
>;

export type TransferEventFilter = TypedEventFilter<TransferEvent>;

export interface VestedTokenGrantEventObject {
  leafHash: string;
}
export type VestedTokenGrantEvent = TypedEvent<
  [string],
  VestedTokenGrantEventObject
>;

export type VestedTokenGrantEventFilter =
  TypedEventFilter<VestedTokenGrantEvent>;

export interface MLTToken extends BaseContract {
  connect(signerOrProvider: Signer | Provider | string): this;
  attach(addressOrName: string): this;
  deployed(): Promise<this>;

  interface: MLTTokenInterface;

  queryFilter<TEvent extends TypedEvent>(
    event: TypedEventFilter<TEvent>,
    fromBlockOrBlockhash?: string | number | undefined,
    toBlock?: string | number | undefined
  ): Promise<Array<TEvent>>;

  listeners<TEvent extends TypedEvent>(
    eventFilter?: TypedEventFilter<TEvent>
  ): Array<TypedListener<TEvent>>;
  listeners(eventName?: string): Array<Listener>;
  removeAllListeners<TEvent extends TypedEvent>(
    eventFilter: TypedEventFilter<TEvent>
  ): this;
  removeAllListeners(eventName?: string): this;
  off: OnEvent<this>;
  on: OnEvent<this>;
  once: OnEvent<this>;
  removeListener: OnEvent<this>;

  functions: {
    VESTING_START_TIMESTAMP(overrides?: CallOverrides): Promise<[BigNumber]>;

    addRoot(
      root_: PromiseOrValue<BytesLike>,
      newRoot_: PromiseOrValue<BytesLike>,
      amount_: PromiseOrValue<BigNumberish>,
      uriIPFS_: PromiseOrValue<string>,
      allocation_: MLTToken.AllocationStruct,
      balanceProof_: PromiseOrValue<BytesLike>[],
      initialAllocationProof_: PromiseOrValue<BytesLike>[],
      newAllocationProof_: PromiseOrValue<BytesLike>[],
      allocationQuantityProof_: PromiseOrValue<BytesLike>[],
      vestingSchedules_: MLTToken.VestingDataStruct[],
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<ContractTransaction>;

    allowance(
      owner: PromiseOrValue<string>,
      spender: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<[BigNumber]>;

    approve(
      spender: PromiseOrValue<string>,
      amount: PromiseOrValue<BigNumberish>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<ContractTransaction>;

    balanceByRootHash(
      arg0: PromiseOrValue<BytesLike>,
      overrides?: CallOverrides
    ): Promise<[BigNumber]>;

    balanceOf(
      account: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<[BigNumber]>;

    batchReleaseVested(
      vestingSchedules_: MLTToken.VestingDataStruct[],
      root_: PromiseOrValue<BytesLike>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<ContractTransaction>;

    decimals(overrides?: CallOverrides): Promise<[number]>;

    decreaseAllowance(
      spender: PromiseOrValue<string>,
      subtractedValue: PromiseOrValue<BigNumberish>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<ContractTransaction>;

    increaseAllowance(
      spender: PromiseOrValue<string>,
      addedValue: PromiseOrValue<BigNumberish>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<ContractTransaction>;

    isTreasurer(
      t_: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<[boolean]>;

    mapRootURIs(
      arg0: PromiseOrValue<BytesLike>,
      overrides?: CallOverrides
    ): Promise<[string]>;

    name(overrides?: CallOverrides): Promise<[string]>;

    releaseVested(
      _beneficiary: PromiseOrValue<string>,
      _amount: PromiseOrValue<BigNumberish>,
      _cliff: PromiseOrValue<BigNumberish>,
      _root: PromiseOrValue<BytesLike>,
      _proof: PromiseOrValue<BytesLike>[],
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<ContractTransaction>;

    rootURIs(
      arg0: PromiseOrValue<BigNumberish>,
      overrides?: CallOverrides
    ): Promise<[string]>;

    rootWhitelist(
      arg0: PromiseOrValue<BytesLike>,
      overrides?: CallOverrides
    ): Promise<[boolean]>;

    symbol(overrides?: CallOverrides): Promise<[string]>;

    totalSupply(overrides?: CallOverrides): Promise<[BigNumber]>;

    transfer(
      to: PromiseOrValue<string>,
      amount: PromiseOrValue<BigNumberish>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<ContractTransaction>;

    transferFrom(
      from: PromiseOrValue<string>,
      to: PromiseOrValue<string>,
      amount: PromiseOrValue<BigNumberish>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<ContractTransaction>;

    verifyProof(
      beneficiary_: PromiseOrValue<string>,
      amount_: PromiseOrValue<BigNumberish>,
      cliff_: PromiseOrValue<BigNumberish>,
      root_: PromiseOrValue<BytesLike>,
      proof_: PromiseOrValue<BytesLike>[],
      overrides?: CallOverrides
    ): Promise<[boolean]>;

    vestingClaimed(
      arg0: PromiseOrValue<BytesLike>,
      overrides?: CallOverrides
    ): Promise<[boolean]>;
  };

  VESTING_START_TIMESTAMP(overrides?: CallOverrides): Promise<BigNumber>;

  addRoot(
    root_: PromiseOrValue<BytesLike>,
    newRoot_: PromiseOrValue<BytesLike>,
    amount_: PromiseOrValue<BigNumberish>,
    uriIPFS_: PromiseOrValue<string>,
    allocation_: MLTToken.AllocationStruct,
    balanceProof_: PromiseOrValue<BytesLike>[],
    initialAllocationProof_: PromiseOrValue<BytesLike>[],
    newAllocationProof_: PromiseOrValue<BytesLike>[],
    allocationQuantityProof_: PromiseOrValue<BytesLike>[],
    vestingSchedules_: MLTToken.VestingDataStruct[],
    overrides?: Overrides & { from?: PromiseOrValue<string> }
  ): Promise<ContractTransaction>;

  allowance(
    owner: PromiseOrValue<string>,
    spender: PromiseOrValue<string>,
    overrides?: CallOverrides
  ): Promise<BigNumber>;

  approve(
    spender: PromiseOrValue<string>,
    amount: PromiseOrValue<BigNumberish>,
    overrides?: Overrides & { from?: PromiseOrValue<string> }
  ): Promise<ContractTransaction>;

  balanceByRootHash(
    arg0: PromiseOrValue<BytesLike>,
    overrides?: CallOverrides
  ): Promise<BigNumber>;

  balanceOf(
    account: PromiseOrValue<string>,
    overrides?: CallOverrides
  ): Promise<BigNumber>;

  batchReleaseVested(
    vestingSchedules_: MLTToken.VestingDataStruct[],
    root_: PromiseOrValue<BytesLike>,
    overrides?: Overrides & { from?: PromiseOrValue<string> }
  ): Promise<ContractTransaction>;

  decimals(overrides?: CallOverrides): Promise<number>;

  decreaseAllowance(
    spender: PromiseOrValue<string>,
    subtractedValue: PromiseOrValue<BigNumberish>,
    overrides?: Overrides & { from?: PromiseOrValue<string> }
  ): Promise<ContractTransaction>;

  increaseAllowance(
    spender: PromiseOrValue<string>,
    addedValue: PromiseOrValue<BigNumberish>,
    overrides?: Overrides & { from?: PromiseOrValue<string> }
  ): Promise<ContractTransaction>;

  isTreasurer(
    t_: PromiseOrValue<string>,
    overrides?: CallOverrides
  ): Promise<boolean>;

  mapRootURIs(
    arg0: PromiseOrValue<BytesLike>,
    overrides?: CallOverrides
  ): Promise<string>;

  name(overrides?: CallOverrides): Promise<string>;

  releaseVested(
    _beneficiary: PromiseOrValue<string>,
    _amount: PromiseOrValue<BigNumberish>,
    _cliff: PromiseOrValue<BigNumberish>,
    _root: PromiseOrValue<BytesLike>,
    _proof: PromiseOrValue<BytesLike>[],
    overrides?: Overrides & { from?: PromiseOrValue<string> }
  ): Promise<ContractTransaction>;

  rootURIs(
    arg0: PromiseOrValue<BigNumberish>,
    overrides?: CallOverrides
  ): Promise<string>;

  rootWhitelist(
    arg0: PromiseOrValue<BytesLike>,
    overrides?: CallOverrides
  ): Promise<boolean>;

  symbol(overrides?: CallOverrides): Promise<string>;

  totalSupply(overrides?: CallOverrides): Promise<BigNumber>;

  transfer(
    to: PromiseOrValue<string>,
    amount: PromiseOrValue<BigNumberish>,
    overrides?: Overrides & { from?: PromiseOrValue<string> }
  ): Promise<ContractTransaction>;

  transferFrom(
    from: PromiseOrValue<string>,
    to: PromiseOrValue<string>,
    amount: PromiseOrValue<BigNumberish>,
    overrides?: Overrides & { from?: PromiseOrValue<string> }
  ): Promise<ContractTransaction>;

  verifyProof(
    beneficiary_: PromiseOrValue<string>,
    amount_: PromiseOrValue<BigNumberish>,
    cliff_: PromiseOrValue<BigNumberish>,
    root_: PromiseOrValue<BytesLike>,
    proof_: PromiseOrValue<BytesLike>[],
    overrides?: CallOverrides
  ): Promise<boolean>;

  vestingClaimed(
    arg0: PromiseOrValue<BytesLike>,
    overrides?: CallOverrides
  ): Promise<boolean>;

  callStatic: {
    VESTING_START_TIMESTAMP(overrides?: CallOverrides): Promise<BigNumber>;

    addRoot(
      root_: PromiseOrValue<BytesLike>,
      newRoot_: PromiseOrValue<BytesLike>,
      amount_: PromiseOrValue<BigNumberish>,
      uriIPFS_: PromiseOrValue<string>,
      allocation_: MLTToken.AllocationStruct,
      balanceProof_: PromiseOrValue<BytesLike>[],
      initialAllocationProof_: PromiseOrValue<BytesLike>[],
      newAllocationProof_: PromiseOrValue<BytesLike>[],
      allocationQuantityProof_: PromiseOrValue<BytesLike>[],
      vestingSchedules_: MLTToken.VestingDataStruct[],
      overrides?: CallOverrides
    ): Promise<void>;

    allowance(
      owner: PromiseOrValue<string>,
      spender: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    approve(
      spender: PromiseOrValue<string>,
      amount: PromiseOrValue<BigNumberish>,
      overrides?: CallOverrides
    ): Promise<boolean>;

    balanceByRootHash(
      arg0: PromiseOrValue<BytesLike>,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    balanceOf(
      account: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    batchReleaseVested(
      vestingSchedules_: MLTToken.VestingDataStruct[],
      root_: PromiseOrValue<BytesLike>,
      overrides?: CallOverrides
    ): Promise<void>;

    decimals(overrides?: CallOverrides): Promise<number>;

    decreaseAllowance(
      spender: PromiseOrValue<string>,
      subtractedValue: PromiseOrValue<BigNumberish>,
      overrides?: CallOverrides
    ): Promise<boolean>;

    increaseAllowance(
      spender: PromiseOrValue<string>,
      addedValue: PromiseOrValue<BigNumberish>,
      overrides?: CallOverrides
    ): Promise<boolean>;

    isTreasurer(
      t_: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<boolean>;

    mapRootURIs(
      arg0: PromiseOrValue<BytesLike>,
      overrides?: CallOverrides
    ): Promise<string>;

    name(overrides?: CallOverrides): Promise<string>;

    releaseVested(
      _beneficiary: PromiseOrValue<string>,
      _amount: PromiseOrValue<BigNumberish>,
      _cliff: PromiseOrValue<BigNumberish>,
      _root: PromiseOrValue<BytesLike>,
      _proof: PromiseOrValue<BytesLike>[],
      overrides?: CallOverrides
    ): Promise<void>;

    rootURIs(
      arg0: PromiseOrValue<BigNumberish>,
      overrides?: CallOverrides
    ): Promise<string>;

    rootWhitelist(
      arg0: PromiseOrValue<BytesLike>,
      overrides?: CallOverrides
    ): Promise<boolean>;

    symbol(overrides?: CallOverrides): Promise<string>;

    totalSupply(overrides?: CallOverrides): Promise<BigNumber>;

    transfer(
      to: PromiseOrValue<string>,
      amount: PromiseOrValue<BigNumberish>,
      overrides?: CallOverrides
    ): Promise<boolean>;

    transferFrom(
      from: PromiseOrValue<string>,
      to: PromiseOrValue<string>,
      amount: PromiseOrValue<BigNumberish>,
      overrides?: CallOverrides
    ): Promise<boolean>;

    verifyProof(
      beneficiary_: PromiseOrValue<string>,
      amount_: PromiseOrValue<BigNumberish>,
      cliff_: PromiseOrValue<BigNumberish>,
      root_: PromiseOrValue<BytesLike>,
      proof_: PromiseOrValue<BytesLike>[],
      overrides?: CallOverrides
    ): Promise<boolean>;

    vestingClaimed(
      arg0: PromiseOrValue<BytesLike>,
      overrides?: CallOverrides
    ): Promise<boolean>;
  };

  filters: {
    "AddedRoot(bytes32)"(
      root?: PromiseOrValue<BytesLike> | null
    ): AddedRootEventFilter;
    AddedRoot(root?: PromiseOrValue<BytesLike> | null): AddedRootEventFilter;

    "Approval(address,address,uint256)"(
      owner?: PromiseOrValue<string> | null,
      spender?: PromiseOrValue<string> | null,
      value?: null
    ): ApprovalEventFilter;
    Approval(
      owner?: PromiseOrValue<string> | null,
      spender?: PromiseOrValue<string> | null,
      value?: null
    ): ApprovalEventFilter;

    "Transfer(address,address,uint256)"(
      from?: PromiseOrValue<string> | null,
      to?: PromiseOrValue<string> | null,
      value?: null
    ): TransferEventFilter;
    Transfer(
      from?: PromiseOrValue<string> | null,
      to?: PromiseOrValue<string> | null,
      value?: null
    ): TransferEventFilter;

    "VestedTokenGrant(bytes32)"(
      leafHash?: PromiseOrValue<BytesLike> | null
    ): VestedTokenGrantEventFilter;
    VestedTokenGrant(
      leafHash?: PromiseOrValue<BytesLike> | null
    ): VestedTokenGrantEventFilter;
  };

  estimateGas: {
    VESTING_START_TIMESTAMP(overrides?: CallOverrides): Promise<BigNumber>;

    addRoot(
      root_: PromiseOrValue<BytesLike>,
      newRoot_: PromiseOrValue<BytesLike>,
      amount_: PromiseOrValue<BigNumberish>,
      uriIPFS_: PromiseOrValue<string>,
      allocation_: MLTToken.AllocationStruct,
      balanceProof_: PromiseOrValue<BytesLike>[],
      initialAllocationProof_: PromiseOrValue<BytesLike>[],
      newAllocationProof_: PromiseOrValue<BytesLike>[],
      allocationQuantityProof_: PromiseOrValue<BytesLike>[],
      vestingSchedules_: MLTToken.VestingDataStruct[],
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<BigNumber>;

    allowance(
      owner: PromiseOrValue<string>,
      spender: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    approve(
      spender: PromiseOrValue<string>,
      amount: PromiseOrValue<BigNumberish>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<BigNumber>;

    balanceByRootHash(
      arg0: PromiseOrValue<BytesLike>,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    balanceOf(
      account: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    batchReleaseVested(
      vestingSchedules_: MLTToken.VestingDataStruct[],
      root_: PromiseOrValue<BytesLike>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<BigNumber>;

    decimals(overrides?: CallOverrides): Promise<BigNumber>;

    decreaseAllowance(
      spender: PromiseOrValue<string>,
      subtractedValue: PromiseOrValue<BigNumberish>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<BigNumber>;

    increaseAllowance(
      spender: PromiseOrValue<string>,
      addedValue: PromiseOrValue<BigNumberish>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<BigNumber>;

    isTreasurer(
      t_: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    mapRootURIs(
      arg0: PromiseOrValue<BytesLike>,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    name(overrides?: CallOverrides): Promise<BigNumber>;

    releaseVested(
      _beneficiary: PromiseOrValue<string>,
      _amount: PromiseOrValue<BigNumberish>,
      _cliff: PromiseOrValue<BigNumberish>,
      _root: PromiseOrValue<BytesLike>,
      _proof: PromiseOrValue<BytesLike>[],
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<BigNumber>;

    rootURIs(
      arg0: PromiseOrValue<BigNumberish>,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    rootWhitelist(
      arg0: PromiseOrValue<BytesLike>,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    symbol(overrides?: CallOverrides): Promise<BigNumber>;

    totalSupply(overrides?: CallOverrides): Promise<BigNumber>;

    transfer(
      to: PromiseOrValue<string>,
      amount: PromiseOrValue<BigNumberish>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<BigNumber>;

    transferFrom(
      from: PromiseOrValue<string>,
      to: PromiseOrValue<string>,
      amount: PromiseOrValue<BigNumberish>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<BigNumber>;

    verifyProof(
      beneficiary_: PromiseOrValue<string>,
      amount_: PromiseOrValue<BigNumberish>,
      cliff_: PromiseOrValue<BigNumberish>,
      root_: PromiseOrValue<BytesLike>,
      proof_: PromiseOrValue<BytesLike>[],
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    vestingClaimed(
      arg0: PromiseOrValue<BytesLike>,
      overrides?: CallOverrides
    ): Promise<BigNumber>;
  };

  populateTransaction: {
    VESTING_START_TIMESTAMP(
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    addRoot(
      root_: PromiseOrValue<BytesLike>,
      newRoot_: PromiseOrValue<BytesLike>,
      amount_: PromiseOrValue<BigNumberish>,
      uriIPFS_: PromiseOrValue<string>,
      allocation_: MLTToken.AllocationStruct,
      balanceProof_: PromiseOrValue<BytesLike>[],
      initialAllocationProof_: PromiseOrValue<BytesLike>[],
      newAllocationProof_: PromiseOrValue<BytesLike>[],
      allocationQuantityProof_: PromiseOrValue<BytesLike>[],
      vestingSchedules_: MLTToken.VestingDataStruct[],
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<PopulatedTransaction>;

    allowance(
      owner: PromiseOrValue<string>,
      spender: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    approve(
      spender: PromiseOrValue<string>,
      amount: PromiseOrValue<BigNumberish>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<PopulatedTransaction>;

    balanceByRootHash(
      arg0: PromiseOrValue<BytesLike>,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    balanceOf(
      account: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    batchReleaseVested(
      vestingSchedules_: MLTToken.VestingDataStruct[],
      root_: PromiseOrValue<BytesLike>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<PopulatedTransaction>;

    decimals(overrides?: CallOverrides): Promise<PopulatedTransaction>;

    decreaseAllowance(
      spender: PromiseOrValue<string>,
      subtractedValue: PromiseOrValue<BigNumberish>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<PopulatedTransaction>;

    increaseAllowance(
      spender: PromiseOrValue<string>,
      addedValue: PromiseOrValue<BigNumberish>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<PopulatedTransaction>;

    isTreasurer(
      t_: PromiseOrValue<string>,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    mapRootURIs(
      arg0: PromiseOrValue<BytesLike>,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    name(overrides?: CallOverrides): Promise<PopulatedTransaction>;

    releaseVested(
      _beneficiary: PromiseOrValue<string>,
      _amount: PromiseOrValue<BigNumberish>,
      _cliff: PromiseOrValue<BigNumberish>,
      _root: PromiseOrValue<BytesLike>,
      _proof: PromiseOrValue<BytesLike>[],
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<PopulatedTransaction>;

    rootURIs(
      arg0: PromiseOrValue<BigNumberish>,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    rootWhitelist(
      arg0: PromiseOrValue<BytesLike>,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    symbol(overrides?: CallOverrides): Promise<PopulatedTransaction>;

    totalSupply(overrides?: CallOverrides): Promise<PopulatedTransaction>;

    transfer(
      to: PromiseOrValue<string>,
      amount: PromiseOrValue<BigNumberish>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<PopulatedTransaction>;

    transferFrom(
      from: PromiseOrValue<string>,
      to: PromiseOrValue<string>,
      amount: PromiseOrValue<BigNumberish>,
      overrides?: Overrides & { from?: PromiseOrValue<string> }
    ): Promise<PopulatedTransaction>;

    verifyProof(
      beneficiary_: PromiseOrValue<string>,
      amount_: PromiseOrValue<BigNumberish>,
      cliff_: PromiseOrValue<BigNumberish>,
      root_: PromiseOrValue<BytesLike>,
      proof_: PromiseOrValue<BytesLike>[],
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    vestingClaimed(
      arg0: PromiseOrValue<BytesLike>,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;
  };
}
